Index: /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChart.cs	(revision 2134)
+++ /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChart.cs	(revision 2135)
@@ -111,4 +111,9 @@
       Repaint();
       EnforceUpdate();
+    }
+
+    public override void Render(Graphics graphics, int width, int height) {
+      graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
+      base.Render(graphics, width, height);
     }
 
@@ -160,7 +165,4 @@
             actualXValues.Add(subEntry.Get(path.ElementAt(1)));
           }
-        } else {
-          xs.Add(double.NaN);
-          actualXValues.Add("NaN");
         }
         if (results.OrdinalVariables.Contains(yDimension)) {
@@ -184,5 +186,10 @@
             actualYValues.Add(subEntry.Get(path.ElementAt(1)));
           }
-        } else {
+        }
+        if (xs.Count() == 0) {
+          xs.Add(double.NaN);
+          actualXValues.Add("NaN");
+        }
+        if (ys.Count() == 0) {
           ys.Add(double.NaN);
           actualYValues.Add("NaN");
@@ -228,5 +235,5 @@
 
     private int CalculateAlpha(int size) {
-      return maxAlpha - (int)((double)(size - minBubbleSize) / (double)(maxBubbleSize - minBubbleSize) * (double)(maxAlpha - minAlpha));
+      return (minAlpha + maxAlpha) / 2;
     }
 
Index: /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.Designer.cs	(revision 2134)
+++ /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.Designer.cs	(revision 2135)
@@ -34,5 +34,4 @@
       this.sizeComboBox = new System.Windows.Forms.ComboBox();
       this.sizeLabel = new System.Windows.Forms.Label();
-      this.invertCheckbox = new System.Windows.Forms.CheckBox();
       this.bubbleChartControl = new HeuristicLab.CEDMA.Charting.BubbleChartControl();
       ((System.ComponentModel.ISupportInitialize)(this.xTrackBar)).BeginInit();
@@ -43,5 +42,6 @@
       // 
       this.yJitterLabel.AutoSize = true;
-      this.yJitterLabel.Location = new System.Drawing.Point(3, 30);
+      this.yJitterLabel.BackColor = System.Drawing.SystemColors.Control;
+      this.yJitterLabel.Location = new System.Drawing.Point(151, 6);
       this.yJitterLabel.Name = "yJitterLabel";
       this.yJitterLabel.Size = new System.Drawing.Size(29, 13);
@@ -53,5 +53,6 @@
       this.xJitterlabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xJitterlabel.AutoSize = true;
-      this.xJitterlabel.Location = new System.Drawing.Point(291, 418);
+      this.xJitterlabel.BackColor = System.Drawing.SystemColors.Control;
+      this.xJitterlabel.Location = new System.Drawing.Point(346, 439);
       this.xJitterlabel.Name = "xJitterlabel";
       this.xJitterlabel.Size = new System.Drawing.Size(29, 13);
@@ -62,8 +63,9 @@
       // 
       this.xTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.xTrackBar.Location = new System.Drawing.Point(326, 418);
+      this.xTrackBar.BackColor = System.Drawing.SystemColors.Control;
+      this.xTrackBar.Location = new System.Drawing.Point(381, 435);
       this.xTrackBar.Maximum = 100;
       this.xTrackBar.Name = "xTrackBar";
-      this.xTrackBar.Size = new System.Drawing.Size(121, 45);
+      this.xTrackBar.Size = new System.Drawing.Size(64, 45);
       this.xTrackBar.TabIndex = 11;
       this.xTrackBar.TickStyle = System.Windows.Forms.TickStyle.None;
@@ -74,5 +76,6 @@
       this.xAxisLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xAxisLabel.AutoSize = true;
-      this.xAxisLabel.Location = new System.Drawing.Point(305, 394);
+      this.xAxisLabel.BackColor = System.Drawing.SystemColors.Control;
+      this.xAxisLabel.Location = new System.Drawing.Point(198, 438);
       this.xAxisLabel.Name = "xAxisLabel";
       this.xAxisLabel.Size = new System.Drawing.Size(15, 13);
@@ -83,6 +86,7 @@
       // 
       this.xAxisComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.xAxisComboBox.BackColor = System.Drawing.SystemColors.ControlLightLight;
       this.xAxisComboBox.FormattingEnabled = true;
-      this.xAxisComboBox.Location = new System.Drawing.Point(326, 391);
+      this.xAxisComboBox.Location = new System.Drawing.Point(219, 435);
       this.xAxisComboBox.Name = "xAxisComboBox";
       this.xAxisComboBox.Size = new System.Drawing.Size(121, 21);
@@ -93,4 +97,5 @@
       // 
       this.yAxisLabel.AutoSize = true;
+      this.yAxisLabel.BackColor = System.Drawing.SystemColors.Control;
       this.yAxisLabel.Location = new System.Drawing.Point(3, 6);
       this.yAxisLabel.Name = "yAxisLabel";
@@ -101,4 +106,5 @@
       // yAxisComboBox
       // 
+      this.yAxisComboBox.BackColor = System.Drawing.SystemColors.ControlLightLight;
       this.yAxisComboBox.FormattingEnabled = true;
       this.yAxisComboBox.Location = new System.Drawing.Point(24, 3);
@@ -110,8 +116,9 @@
       // yTrackBar
       // 
-      this.yTrackBar.Location = new System.Drawing.Point(38, 30);
+      this.yTrackBar.BackColor = System.Drawing.SystemColors.Control;
+      this.yTrackBar.Location = new System.Drawing.Point(186, 3);
       this.yTrackBar.Maximum = 100;
       this.yTrackBar.Name = "yTrackBar";
-      this.yTrackBar.Size = new System.Drawing.Size(107, 45);
+      this.yTrackBar.Size = new System.Drawing.Size(59, 45);
       this.yTrackBar.TabIndex = 10;
       this.yTrackBar.TickStyle = System.Windows.Forms.TickStyle.None;
@@ -121,6 +128,7 @@
       // 
       this.sizeComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.sizeComboBox.BackColor = System.Drawing.SystemColors.ControlLightLight;
       this.sizeComboBox.FormattingEnabled = true;
-      this.sizeComboBox.Location = new System.Drawing.Point(329, 3);
+      this.sizeComboBox.Location = new System.Drawing.Point(324, 3);
       this.sizeComboBox.Name = "sizeComboBox";
       this.sizeComboBox.Size = new System.Drawing.Size(121, 21);
@@ -132,22 +140,10 @@
       this.sizeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.sizeLabel.AutoSize = true;
-      this.sizeLabel.Location = new System.Drawing.Point(259, 6);
+      this.sizeLabel.BackColor = System.Drawing.SystemColors.Control;
+      this.sizeLabel.Location = new System.Drawing.Point(254, 6);
       this.sizeLabel.Name = "sizeLabel";
       this.sizeLabel.Size = new System.Drawing.Size(64, 13);
       this.sizeLabel.TabIndex = 15;
       this.sizeLabel.Text = "Bubble size:";
-      // 
-      // invertCheckbox
-      // 
-      this.invertCheckbox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.invertCheckbox.AutoSize = true;
-      this.invertCheckbox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
-      this.invertCheckbox.Location = new System.Drawing.Point(326, 30);
-      this.invertCheckbox.Name = "invertCheckbox";
-      this.invertCheckbox.Size = new System.Drawing.Size(64, 17);
-      this.invertCheckbox.TabIndex = 16;
-      this.invertCheckbox.Text = "Inverse:";
-      this.invertCheckbox.UseVisualStyleBackColor = true;
-      this.invertCheckbox.CheckedChanged += new System.EventHandler(this.sizeComboBox_SelectedIndexChanged);
       // 
       // bubbleChartControl
@@ -158,8 +154,8 @@
       this.bubbleChartControl.BackColor = System.Drawing.SystemColors.Control;
       this.bubbleChartControl.Chart = null;
-      this.bubbleChartControl.Location = new System.Drawing.Point(3, 81);
+      this.bubbleChartControl.Location = new System.Drawing.Point(0, 30);
       this.bubbleChartControl.Name = "bubbleChartControl";
       this.bubbleChartControl.ScaleOnResize = true;
-      this.bubbleChartControl.Size = new System.Drawing.Size(444, 304);
+      this.bubbleChartControl.Size = new System.Drawing.Size(450, 399);
       this.bubbleChartControl.TabIndex = 17;
       // 
@@ -168,6 +164,4 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.bubbleChartControl);
-      this.Controls.Add(this.invertCheckbox);
       this.Controls.Add(this.sizeLabel);
       this.Controls.Add(this.sizeComboBox);
@@ -179,4 +173,5 @@
       this.Controls.Add(this.yAxisLabel);
       this.Controls.Add(this.yAxisComboBox);
+      this.Controls.Add(this.bubbleChartControl);
       this.Controls.Add(this.yTrackBar);
       this.Name = "BubbleChartView";
@@ -201,5 +196,4 @@
     private System.Windows.Forms.ComboBox sizeComboBox;
     private System.Windows.Forms.Label sizeLabel;
-    private System.Windows.Forms.CheckBox invertCheckbox;
     private BubbleChartControl bubbleChartControl;
   }
Index: /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.cs	(revision 2134)
+++ /trunk/sources/HeuristicLab.CEDMA.Charting/3.3/BubbleChartView.cs	(revision 2135)
@@ -13,18 +13,4 @@
 
 namespace HeuristicLab.CEDMA.Charting {
-  public class BubbleChartViewFactory : IResultsViewFactory {
-    #region IResultsViewFactory Members
-
-    public string Name {
-      get { return "Bubble chart"; }
-    }
-
-    public IControl CreateView(Results results) {
-      return new BubbleChartView(results);
-    }
-
-    #endregion
-  }
-
   public partial class BubbleChartView : ViewBase {
     private Results Results {
@@ -70,7 +56,21 @@
 
     private void sizeComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      bubbleChartControl.Chart.SetBubbleSizeDimension((string)sizeComboBox.SelectedItem, invertCheckbox.Checked);
+      bubbleChartControl.Chart.SetBubbleSizeDimension((string)sizeComboBox.SelectedItem, false);
       UpdateChart();
     }
   }
+
+  public class BubbleChartViewFactory : IResultsViewFactory {
+    #region IResultsViewFactory Members
+
+    public string Name {
+      get { return "Bubble chart"; }
+    }
+
+    public IControl CreateView(Results results) {
+      return new BubbleChartView(results);
+    }
+
+    #endregion
+  }
 }