Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/HeuristicLab.SupportVectorMachines-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/HeuristicLab.SupportVectorMachines-3.2.csproj	(revision 2155)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/HeuristicLab.SupportVectorMachines-3.2.csproj	(revision 2156)
@@ -71,4 +71,6 @@
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -88,4 +90,10 @@
     <Compile Include="SupportVectorEvaluator.cs" />
     <Compile Include="SVMHelper.cs" />
+    <Compile Include="SVMModelView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="SVMModelView.Designer.cs">
+      <DependentUpon>SVMModelView.cs</DependentUpon>
+    </Compile>
     <Compile Include="VariableEvaluationImpactCalculator.cs" />
     <Compile Include="VariableQualityImpactCalculator.cs" />
@@ -145,4 +153,9 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="SVMModelView.resx">
+      <DependentUpon>SVMModelView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2155)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2156)
@@ -47,4 +47,8 @@
       get { return rangeTransform; }
       set { rangeTransform = value; }
+    }
+
+    public override IView CreateView() {
+      return new HeuristicLab.SupportVectorMachines.SVMModelView(this);
     }
 
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs	(revision 2156)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs	(revision 2156)
@@ -0,0 +1,224 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.SupportVectorMachines {
+  partial class SVMModelView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.numberSupportVectorsLabel = new System.Windows.Forms.Label();
+      this.numberOfSupportVectors = new System.Windows.Forms.TextBox();
+      this.rhoLabel = new System.Windows.Forms.Label();
+      this.rho = new System.Windows.Forms.TextBox();
+      this.svmTypeLabel = new System.Windows.Forms.Label();
+      this.costLabel = new System.Windows.Forms.Label();
+      this.nuLabel = new System.Windows.Forms.Label();
+      this.kernelTypeLabel = new System.Windows.Forms.Label();
+      this.gammaLabel = new System.Windows.Forms.Label();
+      this.svmType = new System.Windows.Forms.TextBox();
+      this.kernelType = new System.Windows.Forms.TextBox();
+      this.gamma = new System.Windows.Forms.TextBox();
+      this.cost = new System.Windows.Forms.TextBox();
+      this.nu = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // numberSupportVectorsLabel
+      // 
+      this.numberSupportVectorsLabel.AutoSize = true;
+      this.numberSupportVectorsLabel.Location = new System.Drawing.Point(3, 7);
+      this.numberSupportVectorsLabel.Name = "numberSupportVectorsLabel";
+      this.numberSupportVectorsLabel.Size = new System.Drawing.Size(135, 13);
+      this.numberSupportVectorsLabel.TabIndex = 0;
+      this.numberSupportVectorsLabel.Text = "Number of support vectors:";
+      // 
+      // numberOfSupportVectors
+      // 
+      this.numberOfSupportVectors.Location = new System.Drawing.Point(144, 4);
+      this.numberOfSupportVectors.Name = "numberOfSupportVectors";
+      this.numberOfSupportVectors.ReadOnly = true;
+      this.numberOfSupportVectors.Size = new System.Drawing.Size(100, 20);
+      this.numberOfSupportVectors.TabIndex = 1;
+      // 
+      // rhoLabel
+      // 
+      this.rhoLabel.AutoSize = true;
+      this.rhoLabel.Location = new System.Drawing.Point(3, 33);
+      this.rhoLabel.Name = "rhoLabel";
+      this.rhoLabel.Size = new System.Drawing.Size(30, 13);
+      this.rhoLabel.TabIndex = 2;
+      this.rhoLabel.Text = "Rho:";
+      // 
+      // rho
+      // 
+      this.rho.Location = new System.Drawing.Point(144, 30);
+      this.rho.Name = "rho";
+      this.rho.ReadOnly = true;
+      this.rho.Size = new System.Drawing.Size(100, 20);
+      this.rho.TabIndex = 3;
+      // 
+      // svmTypeLabel
+      // 
+      this.svmTypeLabel.AutoSize = true;
+      this.svmTypeLabel.Location = new System.Drawing.Point(3, 59);
+      this.svmTypeLabel.Name = "svmTypeLabel";
+      this.svmTypeLabel.Size = new System.Drawing.Size(60, 13);
+      this.svmTypeLabel.TabIndex = 4;
+      this.svmTypeLabel.Text = "SVM Type:";
+      // 
+      // costLabel
+      // 
+      this.costLabel.AutoSize = true;
+      this.costLabel.Location = new System.Drawing.Point(2, 137);
+      this.costLabel.Name = "costLabel";
+      this.costLabel.Size = new System.Drawing.Size(31, 13);
+      this.costLabel.TabIndex = 5;
+      this.costLabel.Text = "Cost:";
+      // 
+      // nuLabel
+      // 
+      this.nuLabel.AutoSize = true;
+      this.nuLabel.Location = new System.Drawing.Point(3, 163);
+      this.nuLabel.Name = "nuLabel";
+      this.nuLabel.Size = new System.Drawing.Size(24, 13);
+      this.nuLabel.TabIndex = 6;
+      this.nuLabel.Text = "Nu:";
+      // 
+      // kernelTypeLabel
+      // 
+      this.kernelTypeLabel.AutoSize = true;
+      this.kernelTypeLabel.Location = new System.Drawing.Point(3, 85);
+      this.kernelTypeLabel.Name = "kernelTypeLabel";
+      this.kernelTypeLabel.Size = new System.Drawing.Size(67, 13);
+      this.kernelTypeLabel.TabIndex = 7;
+      this.kernelTypeLabel.Text = "Kernel Type:";
+      // 
+      // gammaLabel
+      // 
+      this.gammaLabel.AutoSize = true;
+      this.gammaLabel.Location = new System.Drawing.Point(3, 111);
+      this.gammaLabel.Name = "gammaLabel";
+      this.gammaLabel.Size = new System.Drawing.Size(46, 13);
+      this.gammaLabel.TabIndex = 8;
+      this.gammaLabel.Text = "Gamma:";
+      // 
+      // svmType
+      // 
+      this.svmType.Location = new System.Drawing.Point(144, 56);
+      this.svmType.Name = "svmType";
+      this.svmType.ReadOnly = true;
+      this.svmType.Size = new System.Drawing.Size(100, 20);
+      this.svmType.TabIndex = 10;
+      // 
+      // kernelType
+      // 
+      this.kernelType.Location = new System.Drawing.Point(144, 82);
+      this.kernelType.Name = "kernelType";
+      this.kernelType.ReadOnly = true;
+      this.kernelType.Size = new System.Drawing.Size(100, 20);
+      this.kernelType.TabIndex = 11;
+      // 
+      // gamma
+      // 
+      this.gamma.Location = new System.Drawing.Point(144, 108);
+      this.gamma.Name = "gamma";
+      this.gamma.ReadOnly = true;
+      this.gamma.Size = new System.Drawing.Size(100, 20);
+      this.gamma.TabIndex = 12;
+      // 
+      // cost
+      // 
+      this.cost.Location = new System.Drawing.Point(144, 134);
+      this.cost.Name = "cost";
+      this.cost.ReadOnly = true;
+      this.cost.Size = new System.Drawing.Size(100, 20);
+      this.cost.TabIndex = 14;
+      // 
+      // nu
+      // 
+      this.nu.Location = new System.Drawing.Point(144, 160);
+      this.nu.Name = "nu";
+      this.nu.ReadOnly = true;
+      this.nu.Size = new System.Drawing.Size(100, 20);
+      this.nu.TabIndex = 15;
+      // 
+      // SVMModelView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.nu);
+      this.Controls.Add(this.cost);
+      this.Controls.Add(this.gamma);
+      this.Controls.Add(this.kernelType);
+      this.Controls.Add(this.svmType);
+      this.Controls.Add(this.gammaLabel);
+      this.Controls.Add(this.kernelTypeLabel);
+      this.Controls.Add(this.nuLabel);
+      this.Controls.Add(this.costLabel);
+      this.Controls.Add(this.svmTypeLabel);
+      this.Controls.Add(this.rho);
+      this.Controls.Add(this.rhoLabel);
+      this.Controls.Add(this.numberOfSupportVectors);
+      this.Controls.Add(this.numberSupportVectorsLabel);
+      this.Name = "SVMModelView";
+      this.Size = new System.Drawing.Size(253, 189);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label numberSupportVectorsLabel;
+    private System.Windows.Forms.TextBox numberOfSupportVectors;
+    private System.Windows.Forms.Label rhoLabel;
+    private System.Windows.Forms.TextBox rho;
+    private System.Windows.Forms.Label svmTypeLabel;
+    private System.Windows.Forms.Label costLabel;
+    private System.Windows.Forms.Label nuLabel;
+    private System.Windows.Forms.Label kernelTypeLabel;
+    private System.Windows.Forms.Label gammaLabel;
+    private System.Windows.Forms.TextBox svmType;
+    private System.Windows.Forms.TextBox kernelType;
+    private System.Windows.Forms.TextBox gamma;
+    private System.Windows.Forms.TextBox cost;
+    private System.Windows.Forms.TextBox nu;
+  }
+}
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2156)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2156)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.SupportVectorMachines {
+  public partial class SVMModelView : ViewBase {
+    private HeuristicLab.Data.SVMModel model;
+    
+    public SVMModelView(HeuristicLab.Data.SVMModel model) : base() {
+      InitializeComponent();
+      this.model = model;
+      model.Changed += (sender, args) => UpdateControls();
+
+      UpdateControls();
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      numberOfSupportVectors.Text = model.Model.SupportVectorCount.ToString();
+      rho.Text = model.Model.Rho.ToString();
+      svmType.Text = model.Model.Parameter.SvmType.ToString();
+      kernelType.Text = model.Model.Parameter.KernelType.ToString();
+      gamma.Text = model.Model.Parameter.Gamma.ToString();
+      cost.Text = model.Model.Parameter.C.ToString();
+      nu.Text = model.Model.Parameter.Nu.ToString();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.resx
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.resx	(revision 2156)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.resx	(revision 2156)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>